
var DEBUG = {
    log: function (str) { console.log(str) },
    error: function (str) { console.error(str) }
}


var LGSync = {

	MASTERIP: "",
	NUM_SCREENS: 0,
	VIDEOS: [],
	VIDEOSYNC_PORT: 14725,
	initFlag_playVideo1: false,
	initFlag_playVideo2: false,
	myIP: "",
	ws: null,
	videoIdx: 0,
	me: '_UNDEFINED_',
	initFlag: false,
	currentVideoTag: 0,
	canplaythrough_c: 0,
	loadVideo_c: 0,
	initFlag_playVideo: false,
	TwoTags: true,
	Version3: true,

	setVids: function(vidList)
	{
		LGSync.VIDEOS = vidList;
	},

	start: function(videoList, theMaster, numScreens)
	{

		try
		{

			if (webOSVersion == "2.0")
			{
				LGSync.TwoTags = false;
			}
		}
		catch (e){}

		if (LGSync.Version3)
		{
			LGSync.videoIdx = -1;
			$("#PingHD").append("<video id='vid1' class='syncVideo' oncanplaythrough='LGSync.TwoTagStart(1, 500)' onended='LGSync.VidEnded(1)'></video>");
		}
		else if (LGSync.TwoTags)
		{
			LGSync.videoIdx = -1;
			$("#PingHD").append("<video id='vid2' class='syncVideo' oncanplaythrough='LGSync.TwoTagStart(2, 500)' onended='LGSync.VidEnded(2)'></video>");
			$("#PingHD").append("<video id='vid1' class='syncVideo' oncanplaythrough='LGSync.TwoTagStart(1, 500)' onended='LGSync.VidEnded(1)'></video>");

		}
		else
			$("#PingHD").append("<img id='myImg' class='syncImg'><video id='vid' class='syncVideo'><source></video>");

		LGSync.VIDEOS = videoList;
		LGSync.MASTERIP = theMaster;
		LGSync.NUM_SCREENS = numScreens;

		setTimeout(function()
		{
			console.log("Getting IP");
			LGSync.getIP(function (ret)
			{
				if (ret !== null)
				{
					console.log(" ip: " + LGSync.myIP);
					LGSync.videoIdx_increase();
					LGSync.loadVideo();
				}
				else
					console.log("error with ip");

			});
		}, 10 * 1000);
	},

	init: function()
	{

		webOS.service.request('luna://com.lg.app.signage.server/',
		{
			method: 'serverOn',
			onSuccess: function ()
			{
				DEBUG.log('SERVER ON');

				LGSync.currentVideoTag = 1;

			},
			onFailure: function (err)
			{
				DEBUG.log('SERVER ON Failure');
				DEBUG.error(JSON.stringify(err));
			},
			subscribe: true
		});



	}, //end init


	connectToServer: function()
	{
		DEBUG.log('connectToServer');
		if (window.WebSocket)
		{
			var url = "ws://" + LGSync.MASTERIP + ":14726";
			DEBUG.log('Websocket enable')
			DEBUG.log('Connect to ' + url)
			LGSync.ws = new WebSocket(url);

			LGSync.ws.onopen = function ()
			{
				DEBUG.log('Open');
				LGSync.ws.send(JSON.stringify({
					command: 'config',
					ip: LGSync.MASTERIP,
					port: LGSync.NUM_SCREENS
				}));
			};

			LGSync.ws.onmessage = function (evt)
			{
				var receivedMsg = JSON.parse(evt.data);

				if (receivedMsg.command === 'wait')
					return;

				DEBUG.log('ws.onmessage ME: ' + LGSync.me);
				DEBUG.log(receivedMsg);

				if (receivedMsg.command === 'setMaster')
				{
					DEBUG.log('setMaster');
					LGSync.me = 'Master';
					if (LGSync.Version3 == true)
					{
						LGSync.ws.send(JSON.stringify({
							command: 'ready',
						}));
						return;
					}

					LGSync.setMaster(function (basetime)
					{
						LGSync.ws.send(JSON.stringify({
							command: 'setMaster',
							ip: LGSync.myIP,
							port: LGSync.VIDEOSYNC_PORT,
							basetime: basetime
						}));
						LGSync.ws.send(JSON.stringify({
							command: 'ready',
						}));
					});
				}
				else if (receivedMsg.command === 'setSlave')
				{
					DEBUG.log('setSlave');
					LGSync.me = 'Slave';

					if (LGSync.Version3 == true)
					{
						LGSync.ws.send(JSON.stringify({
							command: 'ready',
						}));
						return;
					}

					DEBUG.log(JSON.stringify(receivedMsg, null, 4))
					var masterIP = receivedMsg.ip;
					var masterBasetime = receivedMsg.basetime;
					LGSync.setSlave(masterIP, masterBasetime, function ()
					{
						LGSync.ws.send(JSON.stringify({
							command: 'ready',
						}));
					});
				}
				else if (receivedMsg.command === 'playMaster')
				{
					if (LGSync.me === 'Master')
					{

						if (LGSync.Version3)
						{
							LGSync.setMaster(function (basetime)
							{
								LGSync.ws.send(JSON.stringify({
									command: 'setMaster',
									ip: LGSync.myIP,
									port: LGSync.VIDEOSYNC_PORT,
									basetime: basetime
								}));

								DEBUG.log('playMastered');
								LGSync.playVideo(function ()
								{
									LGSync.ws.send(JSON.stringify({
										command: 'masterPlayed',
									}));
								});

							});
							return;
						}

						DEBUG.log('playMastered');
						LGSync.playVideo(function ()
						{
							LGSync.ws.send(JSON.stringify({
								command: 'masterPlayed',
							}));
						});
					}
				}
				else if (receivedMsg.command === 'playSlave')
				{

					if (LGSync.me === 'Slave')
					{

						if (LGSync.Version3)
						{
							var masterIP = receivedMsg.ip;
							var masterBasetime = receivedMsg.basetime;
							LGSync.setSlave(masterIP, masterBasetime, function ()
							{
								LGSync.playVideo(function ()
								{
									DEBUG.log('Slave video play');
								});
							});

							return;
						}

						DEBUG.log('playSlave');
						LGSync.playVideo(function ()
						{
							DEBUG.log('Slave video play');
						});
					}

				}
			};

			LGSync.ws.onclose = function ()
			{
				DEBUG.log('Close');
				setTimeout(function ()
				{
					LGSync.connectToServer();
				}, 1 * 1000);
			};

			LGSync.ws.onerror = function (err)
			{
				DEBUG.log('onerror');
				DEBUG.error(err);
			}
		}


	}, //end connectToServer


	sendMessageToServer: function()
	{
		if (LGSync.me === 'Master')
		{
			DEBUG.log('sendMessageToServer Master');
			LGSync.setMaster(function (basetime)
			{
				LGSync.ws.send(JSON.stringify({
					command: 'setMaster',
					ip: LGSync.myIP,
					port: LGSync.VIDEOSYNC_PORT,
					basetime: basetime
				}));
				LGSync.ws.send(JSON.stringify({
					command: 'ready',
				}));
			});
			DEBUG.log(JSON.stringify({
				command: 'setMaster',
				ip: LGSync.myIP,
				port: LGSync.VIDEOSYNC_PORT,
				//basetime: basetime
			}));
		}
		else if (LGSync.me === 'Slave')
		{
			DEBUG.log('sendMessageToServer Slave');
			LGSync.ws.send(JSON.stringify({
				command: 'setSlave'
			}));

		}

	}, //sendMessageToServer


	loadVideo: function()
	{

		if (LGSync.Version3)
		{
			var video = document.getElementById('vid1');

			var source = video.getElementsByTagName('SOURCE')[0];

			if (source) {
				video.pause();
				source.src = '';
				video.removeChild(source);
			}

			source = document.createElement('SOURCE');

			LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;

			source.src = LGSync.VIDEOS[LGSync.videoIdx];

			video.appendChild(source);
			video.load();

			try
			{
				if (LGSync.videoIdx + 1 == LGSync.VIDEOS.length)
					GetSyncVideos();
			}
			catch (eeee) {}
			LGSync.loadVideo_c++;

			return;
		}

		if (LGSync.TwoTags)
		{

			var vid1 = document.getElementById('vid1');
			var vid2 = document.getElementById('vid2');

			if(LGSync.currentVideoTag === 1) {
				if (vid1.src) {
					vid1.pause();

				}
				vid1.src = '';

				LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;

				vid1.src = LGSync.VIDEOS[LGSync.videoIdx];
				vid1.load();

				console.log('loadVideo 1 successed');

				try
				{
					if (LGSync.videoIdx + 1 == LGSync.VIDEOS.length)
						GetSyncVideos();
				}
				catch (eeee) {}

				//LGSync.TwoTagStart(1, 1000);

			} else if(LGSync.currentVideoTag === 2) {
				if (vid2.src) {
					vid2.pause();

				}
				vid2.src = '';

				LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;
				vid2.src = LGSync.VIDEOS[LGSync.videoIdx];
				vid2.load();


				try
				{
					if (LGSync.videoIdx + 1 == LGSync.VIDEOS.length)
						GetSyncVideos();
				}
				catch (eeee) {}

				console.log('loadVideo 2 successed');
				//LGSync.TwoTagStart(2, 1000);
			}

			LGSync.loadVideo_c++;
			return;
		}

		var video = document.getElementById('vid');
		var source = video.getElementsByTagName('SOURCE')[0];

		//document.getElementById("myImg").style.visibility = 'visible';
		//document.getElementById("myImg").style.height = "100%";

		if (source)
		{
			video.pause();
			source.src = null;
			video.load();
			video.removeChild(source);
		}

		source = document.createElement('SOURCE');
		source.src = LGSync.VIDEOS[LGSync.videoIdx];
		DEBUG.log('loadVideo callback000');

		video.appendChild(source);
		video.load();
		LGSync.loadVideo_c++;

	}, //loadVideo

	setSlave: function(ip, basetime, callback)
	{
		var custom = new Custom();
		custom.VideoSync.setSlave(
			function successCallback(successObject)
			{
				DEBUG.log('setSlave');
				callback();
			},
			function failureCallback(failureObject)
			{
				DEBUG.error('[' + failureObject.errorCode + '] ' + failureObject.errorText);
				//callback();
			},
			{
				ip: ip,
				port: LGSync.VIDEOSYNC_PORT,
				basetime: basetime
			}
		);
	},

	BaseTime: "",

	setMaster: function(callback)
	{
		/*
		if (LGSync.BaseTime != "")
		{
			callback(LGSync.BaseTime);
			return;
		}
		*/

		console.log("Calling set master: " + LGSync.myIP + ", port: " + LGSync.VIDEOSYNC_PORT);

		var custom = new Custom();
		custom.VideoSync.setMaster(
			function successCallback(successObject)
			{
				LGSync.BaseTime = successObject.basetime;
				callback(successObject.basetime);
			},
			function failureCallback(failureObject)
			{
				DEBUG.error('[' + failureObject.errorCode + '] ' + failureObject.errorText);
			},
			{
				ip: LGSync.myIP,
				port: LGSync.VIDEOSYNC_PORT
			}
		);
	},

	TwoTagStart: function(n, mills)
	{
		if (LGSync.Version3)
		{

			LGSync.canplaythrough_c++;

			console.log('canplaythrough_c === loadVideo_c');
			if (LGSync.initFlag === false) {
				LGSync.initFlag = true;
				LGSync.connectToServer();
			} else {
				LGSync.sendMessageToServer();
			}

			return;
		}

		if (n == 1)
		{
			setTimeout(function() {
				vid1.style.visibility = 'visible';
			}, mills);

			setTimeout(function() {
				vid2.style.visibility = 'hidden';
				vid2.src = '';

				console.log('Video 1 canplaythrough');

				LGSync.canplaythrough_c++;

				console.log('canplaythrough_c === loadVideo_c');
				if (LGSync.initFlag === false) {
					LGSync.initFlag = true;
					LGSync.connectToServer();
				} else {
					LGSync.sendMessageToServer();
				}

			}, mills);
		}
		else
		{
			setTimeout(function() {
				vid2.style.visibility = 'visible';
			}, mills);

			setTimeout(function() {
				vid1.style.visibility = 'hidden';
				vid1.src = '';

				LGSync.canplaythrough_c++;
				console.log('canplaythrough_c === loadVideo_c');
				if (LGSync.initFlag === false) {
					LGSync.initFlag = true;
					LGSync.connectToServer();
				} else {
					LGSync.sendMessageToServer();
				}

			}, mills);
		}

	},

	VidEnded: function(n)
	{

		if (LGSync.Version3)
		{
			LGSync.loadVideo();
			return;
		}

		console.log("Video ended: " + n);
		if (n == 1)
			LGSync.currentVideoTag = 2;
		else
			LGSync.currentVideoTag = 1;

		LGSync.loadVideo();

	},

	videoIdx_increase: function()
	{

		if (LGSync.Version3)
		{
			var video = document.getElementById('vid1');

			return;
		}

		if (LGSync.TwoTags)
		{
			var vid1 = document.getElementById('vid1');
			var vid2 = document.getElementById('vid2');

			console.log('videoIdx_increase');

			/*
			$(document).on("ended", "video", function()
			{
				console.log($(this).attr("id") + " ended");
				if ($(this).attr("id") == "vid1")
				{
					LGSync.currentVideoTag = 2;

					LGSync.loadVideo();
				}
				else
				{
					LGSync.currentVideoTag = 1;

					LGSync.loadVideo();
				}

			});

			$(document).on("canplaythrough", "video", function()
			{
				console.log($(this).attr("id") + " canplaythrough");
				if ($(this).attr("id") == "vid1")
				{
					LGSync.TwoTagStart(1, 500);
				}
				else
				{
					LGSync.TwoTagStart(2, 500);
				}

			});
			*/

			/*
			vid1.addEventListener('canplaythrough', function () {
				console.log('vid 1 play through');
				LGSync.TwoTagStart(1, 500);
			});

			vid1.addEventListener('ended', function () {
				console.log('vid 1 end');
				LGSync.currentVideoTag = 2;

				LGSync.loadVideo();
			});


			vid2.addEventListener('canplaythrough', function () {
				console.log('vid 2 play through');
				LGSync.TwoTagStart(2, 500);
			});

			vid2.addEventListener('ended', function () {
				console.log('vid 2 end');
				LGSync.currentVideoTag = 1;

				LGSync.loadVideo();
			});
			*/

			return;
		}

		var video = document.getElementById('vid');
		DEBUG.log('videoIdx_increase');

		video.addEventListener('canplaythrough', function ()
		{
			LGSync.canplaythrough_c++;
			DEBUG.log('loadVideo_c   ' + LGSync.loadVideo_c);
			DEBUG.log('canplaythrough_c   ' + LGSync.canplaythrough_c);

			DEBUG.log('canplaythrough_c  === loadVideo_c');
			if (LGSync.initFlag === false)
			{
				LGSync.initFlag = true;
				LGSync.connectToServer();
			}
			else
			{
				LGSync.sendMessageToServer();
			}

		 });

		video.addEventListener('ended', function ()
		{
			DEBUG.log('Video end');
			LGSync.doCapture();

		});

	}, //videoIdx_increase


	doCapture: function()
	{
		var tmp = false;

		if (tmp)
		{
			setTimeout(function(){
				LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;
				LGSync.loadVideo();
			}, 500);
			return;
		}

		var options = {};
		options.save = false;
		options.thumbnail = false;
		options.imgResolution = 'FHD';

		var successCB = function (cbObject)
		{
			var size = cbObject.size;
			var encoding = cbObject.encoding;
			var data = cbObject.data;

			console.log("Got Data size:" + size);
			console.log("Got Data encoding :" + encoding);

			var capturedElement = document.getElementById('myImg');
			capturedElement.src = 'data:image/jpeg;base64,' + data;

			var video = document.getElementById('vid');
			document.getElementById("myImg").style.visibility = 'visible';
			// document.getElementById("myImg").style.zIndex = 10;
			document.getElementById("myImg").style.height = "100%";


			setTimeout(function(){
				video.style.visibility = 'hidden';
				LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;
				LGSync.loadVideo();

				try
				{
					if (LGSync.videoIdx + 1 == LGSync.VIDEOS.length)
						GetSyncVideos();
				}
				catch (eeee) {}

			}, 500);

		};

		var failureCB = function (cbObject) {
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;

			console.log("Error Code [" + errorCode + "]: " + errorText);
		}

		var signage = new Signage();
		signage.captureScreen(successCB, failureCB, options);

	}, //doCapture


	playVideo: function(callback)
	{
		DEBUG.log('Play video');

		if (LGSync.Version3)
		{
			var video = document.getElementById('vid1');
			video.play();
			if (LGSync.initFlag_playVideo === false)
			{

				LGSync.initFlag_playVideo = true;

				video.addEventListener('play', function ()
				{
					callback();

				});
			}
			return;
		}

		if (LGSync.TwoTags)
		{
			var vid1 = document.getElementById('vid1');
			var vid2 = document.getElementById('vid2');

			if(LGSync.currentVideoTag === 1) {
				vid1.play();

				if (LGSync.initFlag_playVideo1 === false) {
					LGSync.initFlag_playVideo1 = true;

					vid1.addEventListener('play', function () {
						callback();
						console.log('vid 1 play!');
					});
				}
			} else if(LGSync.currentVideoTag === 2) {
				vid2.play();

				if (LGSync.initFlag_playVideo2 === false) {
					LGSync.initFlag_playVideo2 = true;

					vid2.addEventListener('play', function () {
						callback();
						console.log('vid 2 play!');
					});
				}
			}
			return;
		}

		var video = document.getElementById('vid');

		video.play();

		if (LGSync.initFlag_playVideo === false)
		{

			LGSync.initFlag_playVideo = true;

			video.addEventListener('play', function ()
			{
				callback();
				setTimeout(function()
				{
					video.style.visibility = 'visible';
					document.getElementById("myImg").style.visibility = 'hidden';
					document.getElementById("myImg").style.height = "0%";



				}, 500);

			});
		}

	}, //playVideo

	getIP: function(callback)
	{
		function successCb(cbObject)
		{
			if (typeof cbObject === 'object' && typeof cbObject.wired === 'object' && cbObject.wired.ipAddress)
			{
				LGSync.myIP = cbObject.wired.ipAddress;
				callback(LGSync.myIP)
			}
			else if (typeof cbObject === 'object' && typeof cbObject.wifi === 'object' && cbObject.wifi.ipAddress)
			{
				LGSync.myIP = cbObject.wifi.ipAddress;
				callback(LGSync.myIP)
			}
			else
			{
				setTimeout( function() {
				                deviceInfo.getNetworkInfo(successCb, failureCb);
            	}, 5 * 1000);
			}
		};

		function failureCb(cbObject)
		{
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;
			DEBUG.error("IP err [" + errorCode + "]: " + errorText);
			callback(null);
		};

		var deviceInfo = new DeviceInfo();
		deviceInfo.getNetworkInfo(successCb, failureCb);
	}


};
