
var DEBUG = {
    log: function (str) { console.log(str) },
    error: function (str) { console.error(str) }
}


var LGSync = {

	MASTERIP: "",
	NUM_SCREENS: 0,
	VIDEOS: [],
	VIDEOSYNC_PORT: 14725,
	initFlag_playVideo1: false,
	initFlag_playVideo2: false,
	myIP: "",
	ws: null,
	videoIdx: 0,
	me: '_UNDEFINED_',
	initFlag: false,
	currentVideoTag: 0,
	canplaythrough_c: 0,
	loadVideo_c: 0,
	initFlag_playVideo: false,
	TwoTags: true,
	Version3: true,


	CurrentPopup: "",
	DoPopups: false,
	Popups: [],

	DoTimes: false,
	Times: [],

	DoExt: false,
	Exts: [],

	setExts: function(acts)
	{
		LGSync.DoExt = true;
		LGSync.Exts = acts;
	},

	setTimes: function(acts)
	{
		LGSync.DoTimes = true;
		LGSync.Times = acts;
	},

	setActions: function(acts)
	{
		LGSync.DoPopups = true;
		LGSync.Popups = acts;
	},

	setVids: function(vidList)
	{
		LGSync.VIDEOS = vidList;
	},

	start: function(videoList, theMaster, numScreens)
	{

		LGSync.videoIdx = -1;
		$("#PingHD").append("<div id='syncImg'></div><video id='vid1' style='position:absolute;z-index:999999' class='syncVideo' oncanplaythrough='LGSync.TwoTagStart(1, 500)' onended='LGSync.VidEnded(1)'></video>");


		LGSync.VIDEOS = videoList;
		LGSync.MASTERIP = theMaster;
		LGSync.NUM_SCREENS = numScreens;

		setTimeout(function()
		{
			console.log("Getting IP");
			LGSync.getIP(function (ret)
			{
				if (ret !== null)
				{
					console.log(" ip: " + LGSync.myIP);
					LGSync.videoIdx_increase();
					LGSync.loadVideo();
				}
				else
					console.log("error with ip");

			});
		}, 10 * 1000);
	},

	init: function()
	{

		webOS.service.request('luna://com.lg.app.signage.server/',
		{
			method: 'serverOn',
			onSuccess: function ()
			{
				DEBUG.log('SERVER ON');

				LGSync.currentVideoTag = 1;

			},
			onFailure: function (err)
			{
				DEBUG.log('SERVER ON Failure');
				DEBUG.error(JSON.stringify(err));
			},
			subscribe: true
		});



	}, //end init


	connectToServer: function()
	{
		DEBUG.log('connectToServer');
		if (window.WebSocket)
		{
			var url = "ws://" + LGSync.MASTERIP + ":14726?master=" + LGSync.MASTERIP + "&num=" + LGSync.NUM_SCREENS;
			DEBUG.log('Websocket enable')
			DEBUG.log('Connect to ' + url)
			LGSync.ws = new WebSocket(url);

			LGSync.ws.onopen = function ()
			{
				DEBUG.log('Open');
				//LGSync.ws.send(JSON.stringify({
				//	command: 'config',
				//	ip: LGSync.MASTERIP,
				//	port: LGSync.NUM_SCREENS
				//}));
			};

			LGSync.ws.onmessage = function (evt)
			{
				var receivedMsg = JSON.parse(evt.data);

				if (receivedMsg.command === 'wait')
					return;

				DEBUG.log('ws.onmessage ME: ' + LGSync.me);
				DEBUG.log(receivedMsg);

				if (receivedMsg.command === 'setMaster')
				{
					DEBUG.log('setMaster');
					LGSync.me = 'Master';
					LGSync.ws.send(JSON.stringify({
							command: 'ready',
					}));

				}
				else if (receivedMsg.command === 'setSlave')
				{
					DEBUG.log('setSlave');
					LGSync.me = 'Slave';

					DEBUG.log(JSON.stringify(receivedMsg, null, 4));


						LGSync.ws.send(JSON.stringify({
							command: 'ready',
						}));

				}
				else if (receivedMsg.command === 'playMaster')
				{
					if (LGSync.me === 'Master')
					{

						DEBUG.log('playMastered');

						LGSync.setMaster(function (basetime)
						{
							LGSync.ws.send(JSON.stringify({
								command: 'setMaster',
								ip: LGSync.myIP,
								port: LGSync.VIDEOSYNC_PORT,
								basetime: basetime
							}));

							DEBUG.log('playMastered');
							LGSync.playVideo(function ()
							{
								LGSync.ws.send(JSON.stringify({
									command: 'masterPlayed',
								}));
							});

						});



					}
				}
				else if (receivedMsg.command === 'playSlave')
				{

					if (LGSync.me === 'Slave')
					{

						DEBUG.log('playSlave');
						var masterIP = receivedMsg.ip;
						var masterBasetime = receivedMsg.basetime;
						LGSync.setSlave(masterIP, masterBasetime, function ()
						{
							LGSync.playVideo(function ()
							{
								DEBUG.log('Slave video play');
							});
						});


					}

				}
			};

			LGSync.ws.onclose = function ()
			{
				DEBUG.log('Close');
				setTimeout(function ()
				{
					LGSync.connectToServer();
				}, 1 * 1000);
			};

			LGSync.ws.onerror = function (err)
			{
				DEBUG.log('onerror');
				DEBUG.error(err);
			}
		}


	}, //end connectToServer


	sendMessageToServer: function()
	{
		if (LGSync.me === 'Master')
		{
			DEBUG.log('sendMessageToServer Master');
			LGSync.setMaster(function (basetime)
			{
				LGSync.ws.send(JSON.stringify({
					command: 'setMaster',
					ip: LGSync.myIP,
					port: LGSync.VIDEOSYNC_PORT,
					basetime: basetime
				}));
				LGSync.ws.send(JSON.stringify({
					command: 'ready',
				}));
			});
			DEBUG.log(JSON.stringify({
				command: 'setMaster',
				ip: LGSync.myIP,
				port: LGSync.VIDEOSYNC_PORT,
				//basetime: basetime
			}));
		}
		else if (LGSync.me === 'Slave')
		{
			DEBUG.log('sendMessageToServer Slave');
			LGSync.ws.send(JSON.stringify({
				command: 'setSlave'
			}));

		}

	}, //sendMessageToServer


	loadVideo: function()
	{


			var video = document.getElementById('vid1');

			var source = video.getElementsByTagName('SOURCE')[0];

			if (source) {
				video.pause();
				source.src = '';
				video.removeChild(source);
			}

			source = document.createElement('SOURCE');

			LGSync.videoIdx = (LGSync.videoIdx + 1) % LGSync.VIDEOS.length;

			source.src = LGSync.VIDEOS[LGSync.videoIdx];



			video.appendChild(source);
			video.load();

			try
			{
				if (LGSync.videoIdx + 1 == LGSync.VIDEOS.length)
					GetSyncVideos();
			}
			catch (eeee) {}
			LGSync.loadVideo_c++;


	}, //loadVideo

	setSlave: function(ip, basetime, callback)
	{
		var custom = new Custom();
		custom.VideoSync.setSlave(
			function successCallback(successObject)
			{
				DEBUG.log('setSlave');
				callback();
			},
			function failureCallback(failureObject)
			{
				DEBUG.error('[' + failureObject.errorCode + '] ' + failureObject.errorText);
				callback();
			},
			{
				ip: ip,
				port: LGSync.VIDEOSYNC_PORT,
				basetime: basetime
			}
		);
	},

	BaseTime: "",

	setMaster: function(callback)
	{

		console.log("Calling set master: " + LGSync.myIP + ", port: " + LGSync.VIDEOSYNC_PORT);

		var custom = new Custom();
		custom.VideoSync.setMaster(
			function successCallback(successObject)
			{
				LGSync.BaseTime = successObject.basetime;
				callback(successObject.basetime);
			},
			function failureCallback(failureObject)
			{
				DEBUG.error('[' + failureObject.errorCode + '] ' + failureObject.errorText);
			},
			{
				ip: LGSync.myIP,
				port: LGSync.VIDEOSYNC_PORT
			}
		);
	},

	TwoTagStart: function(n, mills)
	{

			LGSync.canplaythrough_c++;

			console.log('canplaythrough_c === loadVideo_c');
			if (LGSync.initFlag === false) {
				LGSync.initFlag = true;
				LGSync.connectToServer();
			} else {
				LGSync.sendMessageToServer();
			}

	},

	VidEnded: function(n)
	{



			LGSync.loadVideo();


	},

	videoIdx_increase: function()
	{


	}, //videoIdx_increase

	ShowImages: false,

	playVideo: function(callback)
	{
		DEBUG.log('Play video');

		try
		{
			if (LGSync.DoPopups)
			{
				var pop = LGSync.Popups[LGSync.videoIdx];

				if (pop != "")
				{
					console.log("Processing POPUP: " + pop);

					$(".popupClasses").hide();
					$("." + pop).show();

					if (pop == "Remove")
					{
						LGSync.ShowImages = false;
						$("#syncImg").html("");
						$("#vid1").show();
						$(".popupClasses video").remove();
					}
					else
					{

						var ex = ".jpg";

						if (LGSync.DoExt)
							ex = LGSync.Exts[LGSync.videoIdx];

						$("#syncImg").html("<img width='608' src='" + LGSync.VIDEOS[LGSync.videoIdx].replace(".mp4", ex) + "'/>");

						LGSync.ShowImages = true;
						$("#vid1").hide();

						$("." + pop).each(function()
						{
							try
							{
								var att = $(this).attr("vid");

								if (att != null && att != undefined && att != "")
								{
									$(this).html("<video autoplay><source src='./content/Uploads/" + att + "' type='video/mp4'></video>");
								}
							}
							catch (sup){}

						});
					}


				}

				if (LGSync.ShowImages)
				{
					var ex5 = ".jpg";

					if (LGSync.DoExt)
						ex5 = LGSync.Exts[LGSync.videoIdx];
					$("#syncImg").html("<img width='608' src='" + LGSync.VIDEOS[LGSync.videoIdx].replace(".mp4", ex5) + "'/>");
				}
			}

		}
		catch (ennn){}

		/*
		if (LGSync.me === 'Master')
		{
			if (LGSync.videoIdx == 0)
			{
				$("#vid1").css("width", "639px");
				$("#Zone7582").html("<video hwz='on' loop autoplay><source src='./content/Uploads/Asset5881.mp4' type='video/mp4'></video>");
				$(".popupClasses").show();
			}
			else if (LGSync.videoIdx == 11)
			{
				$("#vid1").css("width", "1920px");
				$(".popupClasses").hide();
				try
				{
					$(".popupClasses video").remove();
				}
				catch (e) {}
			}

		}
		*/

		var video = document.getElementById('vid1');

		if (LGSync.ShowImages && LGSync.DoTimes)
		{
			setTimeout(function()
			{
				console.log("END OF IMAGE");

				LGSync.loadVideo();


			}, LGSync.Times[LGSync.videoIdx]);

		}
		else
			video.play();

		if (LGSync.initFlag_playVideo === false)
		{

			LGSync.initFlag_playVideo = true;

			video.addEventListener('play', function ()
			{
				callback();

			});
		}


	}, //playVideo

	getIP: function(callback)
	{
		function successCb(cbObject)
		{
			if (typeof cbObject === 'object' && typeof cbObject.wired === 'object' && cbObject.wired.ipAddress)
			{
				LGSync.myIP = cbObject.wired.ipAddress;
				callback(LGSync.myIP)
			}
			else if (typeof cbObject === 'object' && typeof cbObject.wifi === 'object' && cbObject.wifi.ipAddress)
			{
				LGSync.myIP = cbObject.wifi.ipAddress;
				callback(LGSync.myIP)
			}
			else
			{
				setTimeout( function() {
				                deviceInfo.getNetworkInfo(successCb, failureCb);
            	}, 5 * 1000);
			}
		};

		function failureCb(cbObject)
		{
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;
			DEBUG.error("IP err [" + errorCode + "]: " + errorText);
			callback(null);
		};

		var deviceInfo = new DeviceInfo();
		deviceInfo.getNetworkInfo(successCb, failureCb);
	}


};
