var SCAP_FILES = [
    // SCAP v1.2 & v1.3
    'configuration.js',
    'deviceInfo.js',
    'inputSource.js',
    'power.js',
    'signage.js',
    'sound.js',
    'storage.js',
    'video.js',
    // SCAP v1.4, v1.5 & v1.6
    'security.js',
    'time.js',
    'utility.js'
]

var SCAP_FILES_INDEX = {
    '1.0': 7,
    '2.0': 7,
    '3.0': 10,
    '3.2': 10,
    '4.0': 10,
    '6.0': 10
}

var SCAP_PATH = {
    '1.0': './cordova-cd/1.2/',
    '2.0': './cordova-cd/1.3/',
    //'3.0': './cordova-cd/1.5/',
    //'3.2': './cordova-cd/1.5/',
    //'4.0': './cordova-cd/1.6/'
    '3.0': './cordova-cd/latest154/',
    //'3.2': './lgzip5/',//was latest 154
    '3.2': './scap157/',//was latest 154
    //'4.0': './cordova-cd/latest16/'
    //'4.0': './scap163/'

    '4.0': './scap171/cordova-cd/',
    '6.0': './scap171/cordova-cd/'

}

var CORDOVA_PATH = './js/cordova/2.7.0/cordova.webos.js';

/************************************************************************************************
* Select SCAP API version
************************************************************************************************/
var webOSVersion = '';
var ipkVersion = '1.9';
var ipkNum = 1.9

// Create <script>
function createScript(webOSVersion) {
    //document.getElementById('status').innerHTML = '';

    for (var i = 0; i <= SCAP_FILES_INDEX[webOSVersion]; i++)
    {
        var jsPath = SCAP_PATH[webOSVersion] + SCAP_FILES[i];
        var script = document.createElement('SCRIPT');

        script.src = jsPath;
        document.head.appendChild(script);

        console.log('addSCAP---------' + jsPath);
        //document.getElementById('status').innerHTML += 'SCAP API "' + jsPath + '" added!!<br>';


        if (i === SCAP_FILES_INDEX[webOSVersion])
        {
            script.onload = function ()
            {
                createFinish();
            }
        }
    }
}

// Create <script> finish
function createFinish() {

	setTimeout(function()
	{
		EngageApp.onLoad();
		Main.onLoad();

	}, 4000);
}

// Gets webOS Signage version
function getwebOSVersion() {
    var custom = new Custom();

setTimeout(function()
{
	try
	{
		custom.Configuration.setKAM(
		function successCallback2()
		{
			console.log('KAM is enabled.')
		},
		function failureCallback2(failureObject) {
			console.error('[' + failureObject.errorCode + '] ' + failureObject.errorText)
		},
		{
			keepAliveMode : true
		}
		);
	}
	catch (eeee)
	{
		console.log("error calling setKAM: " + eeee.message);
	}

}, 10000);

    custom.Signage.getwebOSVersion(
        function successCallback(successObject)
        {
            webOSVersion = successObject.webOSVersion;

			console.log('webOS Signage version: [' + webOSVersion + ']');

            webOSVersion = webOSVersion.trim();

            console.log('webOS Signage version: [' + webOSVersion + ']');
            //document.getElementById('status').innerHTML = '';
            //document.getElementById('status').innerHTML = 'webOS Signage version: ' + webOSVersion;

			createScript(webOSVersion);

        },
        function failureCallback(failureObject)
        {
            console.error('[' + failureObject.errorCode + ']' + failureObject.errorText);
            webOSVersion = "6.0";
            createScript(webOSVersion);
        }
    )
}