console.clear = function () {
    process.stdout.write('\033c');
}
console.clear();
/**
 * webOS Service
 */
var Service = require('webos-service');
var service = new Service("com.lg.app.signage.server");

/**
 * NPM modules
 */
var WebSocketServer = require('websocket').server;
// var formidable = require('formidable');
var http = require('http');
var url = require("url");
var qs = require('querystring');

/**
 * Port define
 */
var webSocketServer;
var clients = [];
var server = null;
var HTTP_PORT = 14725;
var WEBSOCKET_PORT = 14726;

var NO_OF_MONITORS = 0; //The number of Monitors ready to play video.
var doneCount = 0;
var SetSlaveCount = 0;
var NEW_BASETIME = false;
var IP = {
    Master: '',
}

var MASTER_INFO = {
    IP: '',
    PORT: '',
    BASETIME: 0
};

service.register('serverOn', function(message) {
	try {
		if (server !== null) {
			message.respond({
				returnValue: false,
				errorCode: 'SERVER_ALREADY_OEPNED',
				errorText: 'Server already opened'
				});
			}
			else
			{
				openWebSocketServer();
				message.respond({
				returnValue : true
					});
			}
	} catch(err) {
		message.respond({
			returnValue : false,
			errorCode : 'NO_SERVER',
			errorText : 'Cannot run server'
		});
	}
});

setInterval(function () {
    console.log('=================================')
    console.log(' MASTER INFORMATION');
    console.log(JSON.stringify(MASTER_INFO, null, 4))
    console.log('');
    console.log('doneCount : ' + doneCount)

    console.log('=================================')
}, 5 * 1000)

//////////////////////////////////////////////////////////////////////////
// WebSocket Server
// For staff signage
function openWebSocketServer() {
    console.log('Start');
    server = http.createServer(function (request, response) {
        console.log((new Date()) + ' Received request for ' + request.url);
        response.writeHead(404);
        response.end('Invalid Access');
    });
    server.listen(WEBSOCKET_PORT, function () {

    });
    webSocketServer = new WebSocketServer({
        httpServer: server,
        autoAcceptConnections: false
    });
    function originIsAllowed(origin) {
        return true;
    }

    webSocketServer.on('request', function (request) {
        console.log('Request')
        var connection = request.accept(null, request.origin);

		try
		{
			//console.log(JSON.stringify(connection));

			var queryData = url.parse(request.httpRequest.url, true).query;
			IP.Master = queryData.master;
			NO_OF_MONITORS = parseInt(queryData.num);
		}
		catch (ee)
		{
			console.log("error: " + ee.message);
		}

        console.log('IP : ' + getIP(connection.remoteAddress) + ", master: " + IP.Master + ", num: " + NO_OF_MONITORS);
        clients.push(connection);


        function waiting()
        {
            if (getIP(connection.remoteAddress) !== IP.Master && NEW_BASETIME === true)
            {
                packet = {
                    command: 'setSlave',
                    ip: MASTER_INFO.IP,
                    port: MASTER_INFO.PORT,
                    basetime: MASTER_INFO.BASETIME
                }
                connection.send(JSON.stringify(packet));
				SetSlaveCount++;
				if(SetSlaveCount === NO_OF_MONITORS - 1)
				{
					SetSlaveCount = 0; NEW_BASETIME = false;
					MASTER_INFO = {
								IP: '',
								PORT: '',
								BASETIME: 0
									};
				}
            }
            else
            {
                packet = {
                    command: 'wait'
                }
                connection.send(JSON.stringify(packet));
				//console.log(packet.command);
                //console.log(JSON.stringify(packet, null, 4))
                setTimeout(waiting, 1 * 100);
            }
        }

        if (getIP(connection.remoteAddress) === IP.Master) {
            var packet = {
                command: 'setMaster'
            }
            connection.send(JSON.stringify(packet));
            console.log('setMasterReady');
            NEW_BASETIME = true;
            console.log(JSON.stringify(packet, null, 4));
        } else {
            var packet = {};
            waiting();
        }

        connection.on('message', function (message)
        {


            var receivedObject = JSON.parse(message.utf8Data);

            if (receivedObject.command === 'wait')
            	return;

            //console.log(JSON.stringify(receivedObject, null, 4))
            if (receivedObject.command === 'setMaster')
            {
				console.log(JSON.stringify(receivedObject, null, 4))
                MASTER_INFO.IP = receivedObject.ip;
                MASTER_INFO.PORT = receivedObject.port;
                MASTER_INFO.BASETIME = receivedObject.basetime;
		   		NEW_BASETIME = true;
            }
            else if (receivedObject.command === 'setSlave') {
	          waiting();

            }


            else if (receivedObject.command === 'ready')
            {
				console.log(JSON.stringify(receivedObject, null, 4))
                console.log('Ready : ' + getIP(connection.remoteAddress));
		   		doneCount++;
                if (doneCount === NO_OF_MONITORS) {
                    for (var i in clients) {
                        var client = clients[i];
                        var packet = {
                            command: 'playMaster'
                        }
                        client.send(JSON.stringify(packet));
			     console.log('Play ' + getIP(client.remoteAddress));
                    }
                }
            }
            else if (receivedObject.command === 'masterPlayed')
            {
				console.log(JSON.stringify(receivedObject, null, 4))
                for (var i in clients) {
                    var client = clients[i];
                    var packet = {
                        command: 'playSlave',
                        ip: MASTER_INFO.IP,
						port: MASTER_INFO.PORT,
                        basetime: MASTER_INFO.BASETIME
                    }
                    client.send(JSON.stringify(packet));
		       console.log('Play ' + getIP(client.remoteAddress));
                }
                doneCount = 0;
            }

        });
    });
}

function getIP(remoteAddress) {
    return remoteAddress.replace('::ffff:', '')
}
