

var Service = require('webos-service');
var service = new Service("com.lg.app.signage.service");
console.log("Max: " + Number.MAX_SAFE_INTEGER);
service.activityManager.idleTimeout = Number.MAX_SAFE_INTEGER;
service.register('serverOn', function(message) {
	try {
		//onServer();
		console.log("starting service");
		message.respond({
			returnValue : true
		});

	} catch(err) {
		console.log("error with serverOn: " + err.message);
		message.respond({
			returnValue : false,
			errorCode : 'NO_SERVER',
			errorText : 'Cannot run server'
		});
	}
}/*, function(message)
{
	console.log("Service call 1");


	}*/);


var networkId = "";
var host = "";


console.log("Engage Local Area Network Sync\n\n");

console.log("\n\nStarting server on port 8001....\n\n");


var ws = require("nodejs-websocket");

var url = "ws://" + host + "/Sockets/EngageSocket.ashx?player=" + networkId;

var client;

function ConfigureClient()
{
	client = ws.connect(url);

	client.on("error", function(err)
	{
		console.log(new Date() + " Connection to Engage Server error: " + err.message);

	});

	client.on("close", function(err)
	{
		console.log(new Date() + " Connection to Engage Server closed, retrying in 10 seconds");

		setTimeout(function()
		{
			ConfigureClient();

		}, 10000);

	});

	client.on("connect", function(err)
	{
		console.log(new Date() + " Connected to Engage server");

	});

	client.on("text", function(str)
	{
		var data = eval("(" + str + ")");

		console.log(new Date() + " Group [" + data.Group + "] Interrupt [" + data.Interrupt + "] master: " + GetMaster(data.Group));
		broadcast(data.Interrupt + "_" + data.End + "_" + data.Time, data.Group);

	});

}

if (host != "")
	ConfigureClient();


var master = [];

var server;


//function onServer()
//{
	server = ws.createServer(function (conn) {

		ConfigureConn(conn);

	}).listen(8001);

	server.on("error", function(errObj)
	{
		console.log(new Date() + " err: " + JSON.stringify(errObj));
	});


//}

function onServer()
{
}





function GetMaster(group)
{
	for (var x = 0; x < master.length; x++)
	{
		//console.log(master[x].Group + " " + master[x].Player);

		if (master[x].Group == group)
			return master[x].Player;
	}

	return "";
}

function SetMaster(group, player)
{
	var found = false;
	for (var x = 0; x < master.length; x++)
	{
		if (master[x].Group == group)
		{
			master[x].Player = player;
			found = true;
		}
	}

	if (!found)
		master.push({ Group: group, Player: player });
}


function ConfigureConn(conn)
{
	var id = conn.path.substring(1);
	var groupId = "";

	var sp = id.split('_');
	groupId = sp[0];

	var m = GetMaster(groupId);
	var reset = false;

	if (m == "")
	{
		m = id;
		SetMaster(groupId, m);


		//TODO: send reset to player
		reset = true;
	}

	var count = 0;
	server.connections.forEach(function (connection)
	{
		var idx = connection.path.substring(1);
		var spx = idx.split('_');
		var groupIdx = spx[0];

		if (groupId == groupIdx)
			count++;
	});

	console.log(new Date() + " New connection " + id + ", group: " + groupId + ", master: " + m + ", len: " + count);

	conn.sendText("control " + m);

	if (reset)
	{
		console.log("Sending reset to master");
		conn.sendText("PlayId0_0_0");
	}

	broadcast("NewConn", groupId);

	conn.on("text", function (str)
	{
		broadcast(str, groupId);
	});

	conn.on("close", function (code, reason)
	{
		console.log(new Date() + " Connection closed " + id)
		if (id == GetMaster(groupId))
		{
			CheckMaster(groupId);
		}
	});

	conn.on("error", function(errObj)
	{
		try
		{
			console.log(new Date() + " " + id + " conn err: " + JSON.stringify(errObj));
			//if (id == GetMaster(groupId))
			//{
				//CheckMaster(groupId);
			//}
		}
		catch (sup){}
	});
}

function CheckMaster(g)
{
	//find new master
	console.log(new Date() + " need new master for group: " + g);

	SetMaster(g, "");

	server.connections.forEach(function (connection)
	{
		var cid = connection.path.substring(1);

		var groupId = "";
		var sp = cid.split('_');
		groupId = sp[0];

		if (groupId == g)
		{
			if (GetMaster(g) == "")
				SetMaster(g, cid);
			connection.sendText("control " + GetMaster(g));
		}
	});
}

function broadcast(str, g)
{
	server.connections.forEach(function (connection)
	{
		var id = connection.path.substring(1);
		var groupId = "";

		var sp = id.split('_');
		groupId = sp[0];

		//console.log(groupId + " -- " + g);

		if (groupId == g)
		{
			console.log(new Date() + " " + groupId + ": " + str);
			connection.sendText(str)
		}
	});
}

